#import <Cocoa/Cocoa.h>

#import "PPImageView.h"

@class SyncHelper;

@interface AppDelegate : NSObject 
{
	IBOutlet NSWindow *window;
	IBOutlet PPImageView *imageView;
	IBOutlet NSArrayController *recipeArrayController;
	
	NSPersistentStoreCoordinator *persistentStoreCoordinator;
	NSManagedObjectModel *managedObjectModel;
	NSManagedObjectContext *managedObjectContext;
	
	SyncHelper *syncHelper;
}

- (NSPersistentStoreCoordinator *)persistentStoreCoordinator;
- (NSManagedObjectModel *)managedObjectModel;
- (NSManagedObjectContext *)managedObjectContext;
- (NSString*)applicationSupportFolder;

- (IBAction)saveAction:sender;
- (IBAction)addImage:(id)sender;

- (BOOL)save:(NSError**)error;

- (BOOL)updateMetadataForObjects:(NSSet*)updatedObjects 
               andDeletedObjects:(NSSet*)deletedObjects 
                           error:(NSError**)error;

@end
