#import "RecipeIngredientToUnitOfMeasure.h"

@implementation RecipeIngredientToUnitOfMeasure

//START:createDestinationInstancesForSourceInstance
- (BOOL)createDestinationInstancesForSourceInstance:(NSManagedObject*)source 
                                      entityMapping:(NSEntityMapping*)mapping 
                                            manager:(NSMigrationManager*)manager 
                                              error:(NSError**)error
{
  NSManagedObjectContext *destMOC = [manager destinationContext];
  NSString *destEntityName = [mapping destinationEntityName];
  
  //The unit of measure
  NSString *unit = [source valueForKey:@"unitOfMeasure"];
  
  NSMutableDictionary *userInfo = (NSMutableDictionary*)[manager userInfo];
  if (!userInfo) {
    userInfo = [NSMutableDictionary dictionary];
    [manager setUserInfo:userInfo];
  }
  NSMutableDictionary *unitLookup = [userInfo valueForKey:@"units"];
  if (!unitLookup) {
    unitLookup = [NSMutableDictionary dictionary];
    [userInfo setValue:unitLookup forKey:@"units"];
  }
  NSManagedObject *unitMO = [unitLookup valueForKey:unit];
  if (!unitMO) {
    unitMO = [NSEntityDescription insertNewObjectForEntityForName:destEntityName
                                           inManagedObjectContext:destMOC];
    [unitMO setValue:unit forKey:@"name"];
    [unitLookup setValue:unitMO forKey:unit];
  }
  
  [manager associateSourceInstance:source
           withDestinationInstance:unitMO
                  forEntityMapping:mapping];
  
  return YES;
}
//END:createDestinationInstancesForSourceInstance

//START:createRelationshipsForDestinationInstance
- (BOOL)createRelationshipsForDestinationInstance:(NSManagedObject*)dInstance 
                                    entityMapping:(NSEntityMapping*)mapping 
                                          manager:(NSMigrationManager*)manager 
                                            error:(NSError**)error
{
  return YES;
}
//END:createRelationshipsForDestinationInstance

@end
